"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;

var _checkForNonFunctions = _interopRequireDefault(require("./checkForNonFunctions"));

var _addCreationStack = _interopRequireDefault(require("./addCreationStack"));

function createMiddleware(actionHandlers) {
  if (process.env.NODE_ENV !== 'production') (0, _checkForNonFunctions.default)(actionHandlers, 'actionHandlers');

  var result = function result(store) {
    return function (next) {
      var handleAction = function handleAction(action) {
        var handler = actionHandlers[action.type];
        if (!handler) return next(action);
        return handler(store)(next)(action);
      };

      if (process.env.NODE_ENV !== 'production') handleAction = (0, _addCreationStack.default)(handleAction, 'middleware');
      return handleAction;
    };
  };

  result.actionHandlers = actionHandlers;
  return result;
}