"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createReducer;

var _size2 = _interopRequireDefault(require("lodash/size"));

var _checkForNonFunctions = _interopRequireDefault(require("./checkForNonFunctions"));

var _addCreationStack = _interopRequireDefault(require("./addCreationStack"));

function createReducer(initialState, actionHandlers) {
  if (arguments.length === 1) {
    actionHandlers = initialState;
    initialState = undefined;
  }

  if (process.env.NODE_ENV !== 'production') {
    (0, _checkForNonFunctions.default)(actionHandlers, 'actionHandlers');
  }

  var result;

  if ((0, _size2.default)(actionHandlers)) {
    result = function result() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      var action = arguments.length > 1 ? arguments[1] : undefined;
      var reducer = actionHandlers[action.type];
      return reducer ? reducer(state, action) : state;
    };
  } else {
    result = function result() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      return state;
    };
  }

  if (process.env.NODE_ENV !== 'production') result = (0, _addCreationStack.default)(result, 'reducer');
  result.initialState = initialState;
  result.actionHandlers = actionHandlers;
  return result;
}