"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;

var _checkForNonFunctions = _interopRequireDefault(require("./checkForNonFunctions"));

var _addCreationStack = _interopRequireDefault(require("./addCreationStack"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createMiddleware(actionHandlers) {
  if (process.env.NODE_ENV !== 'production') (0, _checkForNonFunctions.default)(actionHandlers, 'actionHandlers');

  let result = store => next => {
    let handleAction = action => {
      const handler = actionHandlers[action.type];
      if (!handler) return next(action);
      return handler(store)(next)(action);
    };

    if (process.env.NODE_ENV !== 'production') handleAction = (0, _addCreationStack.default)(handleAction, 'middleware');
    return handleAction;
  };

  result.actionHandlers = actionHandlers;
  return result;
}