"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createReducer;

var _size2 = _interopRequireDefault(require("lodash/size"));

var _checkForNonFunctions = _interopRequireDefault(require("./checkForNonFunctions"));

var _addCreationStack = _interopRequireDefault(require("./addCreationStack"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createReducer(initialState, actionHandlers) {
  if (arguments.length === 1) {
    actionHandlers = initialState;
    initialState = undefined;
  }

  if (process.env.NODE_ENV !== 'production') {
    (0, _checkForNonFunctions.default)(actionHandlers, 'actionHandlers');
  }

  let result;

  if ((0, _size2.default)(actionHandlers)) {
    result = (state = initialState, action) => {
      let reducer = actionHandlers[action.type];
      return reducer ? reducer(state, action) : state;
    };
  } else {
    result = (state = initialState) => state;
  }

  if (process.env.NODE_ENV !== 'production') result = (0, _addCreationStack.default)(result, 'reducer');
  result.initialState = initialState;
  result.actionHandlers = actionHandlers;
  return result;
}