"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = prefixReducer;

var _mapKeys2 = _interopRequireDefault(require("lodash/mapKeys"));

var _createReducer = _interopRequireDefault(require("./createReducer"));

var _addCreationStack = _interopRequireDefault(require("./addCreationStack"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function prefixReducer(prefix) {
  return reducer => {
    if (reducer.actionHandlers instanceof Object) {
      return (0, _createReducer.default)(reducer.initialState, (0, _mapKeys2.default)(reducer.actionHandlers, (handler, key) => prefix + key));
    }

    let result = (state, action) => typeof action.type === 'string' && action.type.startsWith(prefix) ? reducer(state, _objectSpread({}, action, {
      type: action.type.substring(prefix.length)
    })) : state;

    if (process.env.NODE_ENV !== 'production') result = (0, _addCreationStack.default)(result, 'reducer');
    return result;
  };
}