"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = prefixReducer;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _mapKeys2 = _interopRequireDefault(require("lodash/mapKeys"));

var _createReducer = _interopRequireDefault(require("./createReducer"));

var _addCreationStack = _interopRequireDefault(require("./addCreationStack"));

function prefixReducer(prefix) {
  return function (reducer) {
    if (reducer.actionHandlers instanceof Object) {
      return (0, _createReducer.default)(reducer.initialState, (0, _mapKeys2.default)(reducer.actionHandlers, function (handler, key) {
        return prefix + key;
      }));
    }

    var result = function result(state, action) {
      return typeof action.type === 'string' && action.type.startsWith(prefix) ? reducer(state, (0, _objectSpread2.default)({}, action, {
        type: action.type.substring(prefix.length)
      })) : state;
    };

    if (process.env.NODE_ENV !== 'production') result = (0, _addCreationStack.default)(result, 'reducer');
    return result;
  };
}